<template>
    <b-jumbotron :header="f.title" :lead="f.status | status" :key="f.txid">
        <h4>Details</h4>
        <div v-if="f.description">Description: {{ f.description }}</div>
        <div v-if="f.amount">Requesting:
            <span style="font-weight: bolder;">{{ f.amount }} BCH</span></div>
        <div>Categories:
            <span v-for="c in f.category" :key="c" style="font-style: italic;">
                #{{ c }}
            </span>
        </div>

        <div style="margin-top: 1em;" v-if="f.announcement">
            <b-link v-for="url in f.announcement" :key="url"
                :href="url" style="padding-right: 1em;">View Announcement</b-link>
        </div>

        <div v-if="f.tx" style="font-weight: bolder; padding: 1em;">
            🥳 This campaign was funded in transaction
                <a :href="f.tx | txToURL">{{ f.tx | shortID }}</a> 🥳
        </div>
        <div v-if="txDetails !== null" style="padding-left: 1em; padding-right: 1em;">
            <p>This flipstarter got <strong>{{ txDetails.vin.length }} pledges.</strong></p>

            <p v-if="txDetails.height">It got funded at {{completedTime}} in block
                <a :href="txDetails.height | blockToURL">#{{txDetails.height}}</a>
            </p>
            <b-container style="margin-top: 0.5em">
                <b-row>
                    <b-col v-if="medianPledge !== -1">
                        📊 The median pledge was {{ medianPledge }} BCH
                    </b-col>
                    <b-col v-if="minPledge !== -1">
                        🐣 The smallest pledge was {{ minPledge }} BCH.
                    </b-col>
                    <b-col v-if="maxPledge !== -1">
                        🐂 The largest pledge was {{ maxPledge }} BCH.
                    </b-col>
                </b-row>
            </b-container>
        </div>

        <div style="margin-top: 1em;">
            <b-button size="lg" block variant="primary" :href="f.url">
                <span v-if="f.status != 'upcoming'">Visit Campaign</span>
                <span v-else>See announcement</span>
            </b-button>
        </div>

        <div style="font-size: 80%; margin-top: 1em;">
            <div v-for="url in f.archive" :key="url">&mdash;&nbsp;<a
                :href="url">Archived copy</a></div>
        </div>
    </b-jumbotron>
</template>

<script lang="ts">
import {
  Watch, Component, Prop, Vue,
} from 'vue-property-decorator';
import { getTransaction } from '../electrum';

Vue.filter('txToURL', (tx: string) => {
  const url = `https://explorer.bitcoinunlimited.info/tx/${tx}`;
  return url;
});

Vue.filter('blockToURL', (block: string) => {
  const url = `https://explorer.bitcoinunlimited.info/block-height/${block}`;
  return url;
});

Vue.filter('shortID', (txid: string) => {
  const shortID = `${txid.slice(0, 6)}...${txid.slice(60)}`;
  return shortID;
});

@Component
export default class CampaignJumbotron extends Vue {
  // eslint-disable-next-line
  @Prop() private f!: any;

  /* eslint-disable-next-line */
  private txDetails: any = null;

  private maxPledge: number | string = -1.0;

  private minPledge: number | string = -1.0;

  private medianPledge: number | string = -1.0;

  private completedTime = '';

  async calculatePledges() {
    /* eslint-disable-next-line */
    const inputTxs = await Promise.all(this.txDetails.vin.map((i: any) => getTransaction(i.txid)));

    const amounts: number[] = [];
    for (let i = 0; i < this.txDetails.vin.length; i += 1) {
      /* eslint-disable-next-line */
      const tx: any = inputTxs[i];
      if (tx === null || tx instanceof Error) {
        console.log('Failed to calculate pledge amounts', tx);
        return;
      }
      /* eslint-disable-next-line */
      const vout = this.txDetails.vin[i].vout;
      // console.log(vout, this.txDetails.vin[i]);
      amounts.push(tx.vout[vout].value_satoshi);
    }
    amounts.sort();
    this.maxPledge = (Math.max(...amounts) / 100000000).toFixed(6);
    this.minPledge = (Math.min(...amounts) / 100000000).toFixed(6);

    const median = (arr: number[]) => {
      const mid = Math.floor(arr.length / 2);
      const nums = [...arr].sort((a, b) => a - b);
      return arr.length % 2 !== 0 ? nums[mid] : (nums[mid - 1] + nums[mid]) / 2;
    };

    this.medianPledge = median(amounts);
    this.medianPledge = (this.medianPledge / 100000000).toFixed(6);
  }

  public async created() {
    await this.updatePledgeTransaction();
  }

  private async updatePledgeTransaction() {
    this.completedTime = '';
    this.maxPledge = -1;
    this.medianPledge = -1;
    this.minPledge = -1;
    this.txDetails = null;
    if (!this.f.tx) {
      return;
    }
    try {
      const details = await getTransaction(this.f.tx);
      if (details instanceof Error) {
        throw details;
      }
      this.txDetails = details;
      if (!this.txDetails) {
        return;
      }
      this.completedTime = (new Date(this.txDetails.blocktime * 1000)).toLocaleDateString();
      await this.calculatePledges();
    } catch (e) {
      console.info('getTranscation', e);
    }
  }

  @Watch('f')
  public async onFlipstarterChange() {
    await this.updatePledgeTransaction();
  }
}
</script>
